Package org.apache.storm.topology

## Class WindowedBoltExecutor

- java.lang.Object
- - org.apache.storm.topology.WindowedBoltExecutor

- All Implemented Interfaces:
    `Serializable`, `IBolt`, `IComponent`, `IRichBolt`
  Direct Known Subclasses:
    `PersistentWindowedBoltExecutor`, `StatefulWindowedBoltExecutor`

      public class WindowedBoltExecutor
      extends Object
      implements IRichBolt

  An `IWindowedBolt` wrapper that does the windowing of tuples.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `LATE_TUPLE_FIELD` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `WindowedBoltExecutor​(IWindowedBolt bolt)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `boltExecute​(Supplier<Iterator<Tuple>> tuples, Supplier<Iterator<Tuple>> newTuples, Supplier<Iterator<Tuple>> expiredTuples, Long timestamp)` |
    `protected void` | `boltExecute​(List<Tuple> tuples, List<Tuple> newTuples, List<Tuple> expiredTuples, Long timestamp)` |
    `void` | `cleanup()` | Called when an IBolt is going to be shutdown.
    `void` | `declareOutputFields​(OutputFieldsDeclarer declarer)` | Declare the output schema for all the streams of this topology.
    `protected void` | `doPrepare​(Map<String,​Object> topoConf, TopologyContext context, OutputCollector collector, Collection<Event<Tuple>> queue, boolean stateful)` |
    `void` | `execute​(Tuple input)` | Process a single tuple of input.
    `Map<String,​Object>` | `getComponentConfiguration()` | Declare configuration specific to this component.
    `protected Map<String,​Optional<?>>` | `getState()` |
    `protected int` | `getTopologyTimeoutMillis​(Map<String,​Object> topoConf)` |
    `protected WindowLifecycleListener<Tuple>` | `newWindowLifecycleListener()` |
    `void` | `prepare​(Map<String,​Object> topoConf, TopologyContext context, OutputCollector collector)` | Called when a task for this component is initialized within a worker on the cluster.
    `protected void` | `restoreState​(Map<String,​Optional<?>> state)` |
    `protected void` | `start()` | Start the trigger policy and waterMarkEventGenerator if set.
    `protected void` | `validate​(Map<String,​Object> topoConf, BaseWindowedBolt.Count windowLengthCount, BaseWindowedBolt.Duration windowLengthDuration, BaseWindowedBolt.Count slidingIntervalCount, BaseWindowedBolt.Duration slidingIntervalDuration)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### LATE_TUPLE_FIELD

          public static final String LATE_TUPLE_FIELD

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### WindowedBoltExecutor

          public WindowedBoltExecutor​(IWindowedBolt bolt)

  - ### Method Detail

    - #### getTopologyTimeoutMillis

          protected int getTopologyTimeoutMillis​(Map<String,​Object> topoConf)

    - #### validate

          protected void validate​(Map<String,​Object> topoConf,
                                  BaseWindowedBolt.Count windowLengthCount,
                                  BaseWindowedBolt.Duration windowLengthDuration,
                                  BaseWindowedBolt.Count slidingIntervalCount,
                                  BaseWindowedBolt.Duration slidingIntervalDuration)

    - #### restoreState

          protected void restoreState​(Map<String,​Optional<?>> state)

    - #### getState

          protected Map<String,​Optional<?>> getState()

    - #### start

          protected void start()

      Start the trigger policy and waterMarkEventGenerator if set.

    - #### prepare

          public void prepare​(Map<String,​Object> topoConf,
                              TopologyContext context,
                              OutputCollector collector)

      Description copied from interface: `IBolt`
      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Specified by:
        `prepare` in interface `IBolt`
      Parameters:
        `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task's place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### doPrepare

          protected void doPrepare​(Map<String,​Object> topoConf,
                                   TopologyContext context,
                                   OutputCollector collector,
                                   Collection<Event<Tuple>> queue,
                                   boolean stateful)

    - #### execute

          public void execute​(Tuple input)

      Description copied from interface: `IBolt`
      Process a single tuple of input. The Tuple object contains metadata on it about which component/stream/task it came from. The values of the Tuple can be accessed using Tuple#getValue. The IBolt does not have to process the Tuple immediately. It is perfectly fine to hang onto a tuple and process it later (for instance, to do an aggregation or join).

      Tuples should be emitted using the OutputCollector provided through the prepare method. It is required that all input tuples are acked or failed at some point using the OutputCollector. Otherwise, Storm will be unable to determine when tuples coming off the spouts have been completed.

      For the common case of acking an input tuple at the end of the execute method, see IBasicBolt which automates this.

      Specified by:
        `execute` in interface `IBolt`
      Parameters:
        `input` - The input tuple to be processed.

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`
      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`

    - #### declareOutputFields

          public void declareOutputFields​(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`
      Declare the output schema for all the streams of this topology.
      Specified by:
        `declareOutputFields` in interface `IComponent`
      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

    - #### getComponentConfiguration

          public Map<String,​Object> getComponentConfiguration()

      Description copied from interface: `IComponent`
      Declare configuration specific to this component. Only a subset of the "topology.*" configs can be overridden. The component configuration can be further overridden when constructing the topology using `TopologyBuilder`
      Specified by:
        `getComponentConfiguration` in interface `IComponent`

    - #### newWindowLifecycleListener

          protected WindowLifecycleListener<Tuple> newWindowLifecycleListener()

    - #### boltExecute

          protected void boltExecute​(List<Tuple> tuples,
                                     List<Tuple> newTuples,
                                     List<Tuple> expiredTuples,
                                     Long timestamp)

    - #### boltExecute

          protected void boltExecute​(Supplier<Iterator<Tuple>> tuples,
                                     Supplier<Iterator<Tuple>> newTuples,
                                     Supplier<Iterator<Tuple>> expiredTuples,
                                     Long timestamp)